

/********************************************************************/
/*							            */
/*							            */
/* Splitit is a program which can split files by size & number      */
/* Written by Sreejith S					    */
/* E-Mail Sreejithsin@hotpop.com                                     */
/* Splitit is a free software . do anything with it !               */
/*							            */
/* There is NO warranty ; not even for MERCHANTABILITY or 	    */						            
/* FITNESS FOR A PARTICULAR PURPOSE 				    */			            
/* 							            */
/* 							            */
/* 							            */
/********************************************************************/
		




#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

int split_by_number ( char *filename , int no_of_segments ) ;
int split_by_size ( char *filename  , int size_of_segment ) ;

int main ( argc , argv ) 

	int argc ;
	char *argv[] ;

{
        int c ;
	char *bvalue ;
	extern char *optarg ;
	int no_of_segments , size_of_segment ;
	
        if ( argc > 3  ) 
        {     
	       printf ( "%s : Invalid usage !\n" , argv[0] ) ; 
	       printf ( "Try split -h for more information  \n" ) ;
	       return (0) ;
        }

	if ( argc == 1 )
	{
	       printf ("%s : Try %s -h for more information  .\n",argv[0],argv[0] ) ;
	       return (0) ;
	}       

       while ( ( c = getopt ( argc , argv , "n:s:hv" )  ) != EOF ) 
       {
	       switch (c)
	       {
          		 
        case 'n' :

		  bvalue = optarg ;
                  if ( argc != 3 ) 
		  {
			  printf ( "%s : Invalid usage \nTry split -h for more information. \n", argv[0] ) ;
			  return (0);
		  }
		  else 
		  {
		          no_of_segments = atoi ( bvalue ) ; 	    	          
                          split_by_number ( argv[2] , no_of_segments ) ;	
		  }
		  
		 break ;

        case 's' :

		  bvalue = optarg ;
                  if ( argc != 3 ) 
		  {
			  printf ( "%s : Invalid usage \nTry split -h for more information. \n", argv[0] ) ;
			  return (0);
		  }
		  else 
		  {
		          size_of_segment = atoi ( bvalue ) ; 	    	          
                          split_by_size ( argv[2] , size_of_segment ) ;	
		  }
		  
		 break ;
         
        case 'h' :

 	         printf ( "\n%s usage : %s -n[number] -s[size] -hv [file name] \n\n", argv[0] , argv[0] ) ;
		 printf ( "-n:[number of segs]  -  splits by number \n");
		 printf ( "-s:[size in bytes]   -  splits by size \n" ) ; 
                 printf ( "-v                   -  prints version \n" ) ;
		 printf ( "-h                   -  prints this help \n\n" ) ;    		 
		 
	         break ;		 
	
	case 'v' :
		 
		 printf ( "\n%s Version 1.0  # Sreejith S \n\n", argv[0] ) ;
		 printf ( "This is a free software . U can do anything with it ! \n" ) ;
		 printf ( "There is NO warranty ; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE \n\n" ) ;	
		 break ;
		          
	default : 

        	 printf ( "Try split -h for more information.  \n" ) ;
		 return (0);
		 break ;
	       }
       }
       
		 	       
 return (0) ;

}
		     
                  
/* splitting function .... by number */

int split_by_number ( char *filename , int no_of_segments )
{

     FILE *fp_source , *fp  ; 

     static char split[50] ;
     int length ;
     unsigned long int size_of_source=0,size_of_segment=0 ;
     unsigned long int count=0 , count1=0 ;
     char *buffer ;
     

     fp_source = fopen(filename,"rb") ;
     if (fp_source == NULL)
	      {
	      perror("") ;
	      return (0) ;
	      }


     while(!feof(fp_source))
	 {
	 fgetc(fp_source) ;
	 size_of_source++ ;
	 }

     rewind(fp_source) ;


     size_of_segment = size_of_source / no_of_segments ;

     for( count = 1; count < no_of_segments ; count++)
      {
  
      sprintf ( split , "%s%d" , filename , count ) ;
      fp = fopen(split,"wb") ;
      if(fp == NULL)
	     {
	     perror("") ;
	     return (0) ;
	     }

      if ( (buffer = (char *)( malloc ( size_of_segment ))) == NULL ) 
       {
             perror ("Malloc : " ) ;
	     return (0) ;
       }	     
	     
      fread ( buffer , size_of_segment , 1 , fp_source ) ;
      fwrite ( buffer , size_of_segment , 1 , fp ) ;
      
      free (buffer) ;
      
      fclose(fp) ;

      }

      sprintf ( split , "%s%d" , filename , no_of_segments ) ;
      fp = fopen(split,"wb") ;
      if(fp == NULL)
	     {
	     perror("") ;
	     return (0) ;
	     }

        buffer = (char *)(malloc (size_of_source - (no_of_segments-1)*size_of_segment-1)) ;
        fread ( buffer , (size_of_source - (no_of_segments-1)*size_of_segment-1) , 1 , fp_source ) ;
        fwrite ( buffer ,(size_of_source - (no_of_segments-1)*size_of_segment-1) , 1 , fp ) ;
        
        free (buffer) ;
	fclose(fp) ;
	fclose(fp_source) ;

    return (0) ;
}
   

/* splitting function .... by size  */

int split_by_size ( char *filename , int size_of_segment )
{

     FILE *fp_source , *fp  ; 

     static char split[50] ;
     int length , no_of_segments ;
     unsigned long int size_of_source=0 ;
     unsigned long int count=0 , count1=0 ;
     char *buffer ;
     

     fp_source = fopen(filename,"rb") ;
     if (fp_source == NULL)
	      {
	      perror("") ;
	      return (0) ;
	      }


     while(!feof(fp_source))
	 {
	 fgetc(fp_source) ;
	 size_of_source++ ;
	 }

     rewind(fp_source) ;

     no_of_segments = size_of_source / size_of_segment ;
     if ( size_of_source % size_of_segment != 0 ) no_of_segments ++ ;
     
     for( count = 1; count < no_of_segments ; count++)
      {
  
      sprintf ( split , "%s%d" , filename , count ) ;
      fp = fopen(split,"wb") ;
      if(fp == NULL)
	     {
	     perror("") ;
	     return (0) ;
	     }

      if ( (buffer = (char *)( malloc ( size_of_segment ))) == NULL ) 
       {
             perror ("Malloc : " ) ;
	     return (0) ;
       }	     
	     
      fread ( buffer , size_of_segment , 1 , fp_source ) ;
      fwrite ( buffer , size_of_segment , 1 , fp ) ;
      
      free (buffer) ;
      
      fclose(fp) ;

      }

      sprintf ( split , "%s%d" , filename , no_of_segments ) ;
      fp = fopen(split,"wb") ;
      if(fp == NULL)
	     {
	     perror("") ;
	     return (0) ;
	     }

        buffer = (char *)(malloc (size_of_source - (no_of_segments-1)*size_of_segment-1)) ;
        fread ( buffer , (size_of_source - (no_of_segments-1)*size_of_segment-1) , 1 , fp_source ) ;
        fwrite ( buffer ,(size_of_source - (no_of_segments-1)*size_of_segment-1) , 1 , fp ) ;
        
        free (buffer) ;
	fclose(fp) ;
	fclose(fp_source) ;

    return (0) ;
}
 